#!/usr/bin/perl

################################################################
## search for anything that looks like a C file with a line number
## e.g. /some/file.c:1234
## 
## line number becomes ACT_PATH_LINE variable
## file path becames ACT_SEARCH_FILE
## in case the file path is just a fragment (not a full path), 
## Tactor will search for the best match
##
##	NOTE: if you want to modify this script, copy it to your home directory first
##	~/Library/Application Support/Tactor/PlugIns/
##	Otherwise it may get overwriten next time you update Tactor
################################################################

sub matches_context {
	$TEXT = $CONTEXT{'CTX_TEXT'};
	foreach (split ('[\n;]', $TEXT)) {
		$l = $_;
		print ("$_\n");
		if ($l =~ m/(([a-zA-Z0-9_]+)\.([ch])):(\d+)/) {
			$CONTEXT{'ACT_PATH_LINE'} = $4;
			$CONTEXT{'ACT_SEARCH_FILE'} = $1;
			return 1;
		}

	}
	return 0;
}

#################################################################
## for testing purposes
#################################################################

if ($ARGV[0] eq "--test") {
	my $txtin = "";
	while (<STDIN>) {
		$txtin .= $_;
	}

	%CONTEXT = ();
	$CONTEXT{'CTX_TEXT'} = $txtin;

	my $rv = matches_context ();
	if ($rv) {
		foreach (keys (%CONTEXT)) {
			print ($_ . "=" . $CONTEXT{$_} . "\n");
		}
	}
}
